/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        23.12.2007
 Description:    RS232 Softuart Routinen (nur Senden)
----------------------------------------------------------------------------*/

#include "softuart.h"

//----------------------------------------------------------------------------
//Softuart init
void softuart_init(void){
	//Port D5 als TX Pin
	PORTD |= (1<<PD5);
	DDRD |= (1<<PD5);
	
}

//----------------------------------------------------------------------------
//Ausgabe eines Strings
void soft_uart_write_str(unsigned char *str)
{
	while (*str)
	{
		soft_uart_write_char(*str++);
	}
}

void soft_uart_write_data(unsigned char *str){
	int i=0;
	for (;i<512;i++){
		soft_uart_write_char(*str++);
	}
}

//----------------------------------------------------------------------------
//Softuart write char
void soft_uart_write_char(unsigned char c){
		unsigned char bit_count = 8;
		//Startbit senden
		PORTD &= ~(1<<5);
		//_delay_us(DELAY_TIME);
		unsigned char j;
	    for (j = 0; j < 25; j++){
			asm volatile("NOP");
		};

		do
		{
			if (c & 0x01)
			{
				PORTD |= (1<<5);
			}
			else
			{
				PORTD &= ~(1<<5);
			}
			//wait
			//_delay_us(DELAY_TIME);
		    for (j = 0; j < 25; j++){
				asm volatile("NOP");
			};
			c = c>>1;
			
		}while(--bit_count);
		//Stopbit wird gesendet
		PORTD |= (1<<5);
		//Warten bis neu gesendet werden kann
		//_delay_us(DELAY_TIME);
	    for (j = 0; j < 25; j++){
			asm volatile("NOP");
		};
}


